import { DateAdapter } from '@rschedule/core';
import { ISerializeToJSONOptions } from '@rschedule/json-tools';
declare module '@rschedule/core/generators' {
  namespace Dates {
    interface JSON {
      type: 'Dates';
      timezone?: string | null;
      dates: DateAdapter.JSON[];
      data?: unknown;
    }
  }
  class Dates<Data = any> extends OccurrenceGenerator {
    static fromJSON<D = any>(
      json: Dates.JSON,
      options?: {
        timezone?: string | null;
        data?: (json: OccurrenceGenerator.JSON) => any;
      },
    ): Dates<D>;
    toJSON(opts?: ISerializeToJSONOptions): Dates.JSON;
  }
}
