import { OccurrenceGenerator } from '@rschedule/core/generators';
export declare class ParseJSONError extends Error {}
export declare class SerializeJSONError extends Error {}
export interface ISerializeToJSONOptions {
  nested?: boolean;
  data?:
    | boolean
    | ((
        arg: OccurrenceGenerator & {
          data?: any;
        },
      ) => any);
}
export declare type ISerializeFromJSONFn = (
  json: any,
  options?: {
    timezone?: string | null;
  },
) => OccurrenceGenerator;
declare module '@rschedule/core/generators' {
  namespace OccurrenceGenerator {
    interface JSON {
      type: string;
    }
  }
  abstract class OccurrenceGenerator {
    static JSON_FN_MAP: Map<string, ISerializeFromJSONFn>;
    static fromJSON(
      json: OccurrenceGenerator.JSON,
      options?: {
        timezone?: string | null;
        data?: (
          json: OccurrenceGenerator.JSON & {
            data?: any;
          },
        ) => any;
      },
    ): OccurrenceGenerator;
    toJSON(opts?: ISerializeToJSONOptions): OccurrenceGenerator.JSON;
  }
}
export declare function serializeDataToJSON(
  gen: OccurrenceGenerator & {
    data?: any;
  },
  json: any,
  opt: {
    data?:
      | boolean
      | ((
          arg: OccurrenceGenerator & {
            data?: any;
          },
        ) => any);
  },
): void;
export declare function registerJSONSerializerFn(
  name: string,
  fn: (
    json: any,
    options?: {
      [key: string]: any;
    },
  ) => any,
): void;
