import { DateAdapter, IRuleOptions } from '@rschedule/core';
import { ISerializeToJSONOptions } from '@rschedule/json-tools';
interface JSONDates {
  start: DateAdapter.JSON;
  end?: DateAdapter.JSON;
}
export interface IRuleOptionsJSON
  extends Omit<IRuleOptions, 'start' | 'end'>,
    JSONDates {}
declare module '@rschedule/core/generators' {
  namespace Rule {
    interface JSON {
      type: 'Rule';
      config: IRuleOptionsJSON;
      timezone?: string | null;
      data?: unknown;
    }
  }
  abstract class Rule<Data = any> extends OccurrenceGenerator {
    static fromJSON<D = any>(
      json: Rule.JSON,
      options?: {
        timezone?: string | null;
        data?: (json: OccurrenceGenerator.JSON) => any;
      },
    ): Rule<D>;
    toJSON(opts?: ISerializeToJSONOptions): Rule.JSON;
  }
}
export {};
