import { ISerializeToJSONOptions } from '@rschedule/json-tools';
import '@rschedule/json-tools/Dates';
import '@rschedule/json-tools/Rule';
declare module '@rschedule/core/generators' {
  namespace Schedule {
    interface JSON {
      type: 'Schedule';
      timezone?: string | null;
      rrules: Rule.JSON[];
      exrules: Rule.JSON[];
      rdates: Dates.JSON;
      exdates: Dates.JSON;
      data?: unknown;
    }
  }
  class Schedule<Data = any> extends OccurrenceGenerator {
    static fromJSON<D = any>(
      json: Schedule.JSON,
      options?: {
        timezone?: string | null;
        data?: (json: OccurrenceGenerator.JSON) => any;
      },
    ): Schedule<D>;
    toJSON(opts?: ISerializeToJSONOptions): Schedule.JSON;
  }
}
